unit atmSlotMachine;

{ **************************************************************************** }
{ *                                                                          * }
{ *                                                         * }
{ *                                                                          * }
{ **************************************************************************** }

interface
  uses
    Automaton;
type

{ **************************************************************************** }
{ *                                                                          * }
{ *   : TAutomatonSlotMachine.                                 * }
{ *  :      ,   " " (0).      * }
{ *                                                                          * }
{ **************************************************************************** }

  TAutomatonSlotMachine = class (TAutomaton)
  protected
    procedure HandleState(Event: TEvent); override;
    procedure EnterState();  override;
    procedure Log(AutomatonMessage: string); override;
    //    
    function  GetY1: TState;      //    A1.
    function  GetY2: TState;      //    A2.
    //   
    function  GetX01(): boolean;  // "C    "
    function  GetX02(): boolean;  // "   "
    //  
    procedure z02();              // " "
    procedure z03();              // " "
    procedure z04();              // "   "
    procedure z05();              // "  "
    procedure z12();              // "  "
    procedure z13();              // " "
    procedure z28();              // "  "
    procedure z15();              // "  "
    //  
    procedure A1(Event:TEvent);   //   A1.
    procedure A2(Event:TEvent);   //   A2.
  protected
    //  ,     .
    property  y1: TState read GetY1;
    property  y2: TState read GetY2;
  public
    //  ,     .
    property  x01: boolean read GetX01;
    property  x02: boolean read GetX02;
  end;

{ **************************************************************************** }
{ *                                                                          * }
{ *   : TAutomatonMoneyTray.                                   * }
{ *  :      ,   "" (1).      * }
{ *                                                                          * }
{ **************************************************************************** }

  TAutomatonMoneyTray = class (TAutomaton)
  protected
    procedure HandleState(Event: TEvent); override;
    procedure EnterState();  override;
    procedure Log(AutomatonMessage: string); override;
    //   
    function  GetX11(): boolean; // " "
    //  
    procedure z02();             // " "
    procedure z13();             // "   "
    procedure z12();             // "  "
    procedure z14();             // " "
    procedure z15();             // "  "
    //  
    procedure A0(Event:TEvent);  //   A0.
  public
    //  ,     .
    property  x11: boolean read GetX11;
  end;

{ **************************************************************************** }
{ *                                                                          * }
{ *   : TAutomatonBarrelsEngine.                               * }
{ *  :      ,   " " (2).    * }
{ *                                                                          * }
{ **************************************************************************** }

  TAutomatonBarrelsEngine = class (TAutomaton)
  protected
    procedure HandleState(Event: TEvent); override;
    procedure EnterState();  override;
    procedure Log(AutomatonMessage: string); override;
    //  
    procedure z20();             // " "
    procedure z21();             // "   "
    procedure z23();             // "   "
    procedure z25();             // "   "
    procedure z27();             // "  "
    procedure z28();             // "  "
  end;

{ **************************************************************************** }
{ *                                                                          * }
{ *                                                         * }
{ *                                                                          * }
{ **************************************************************************** }

implementation
uses
  SysUtils,
  FormMain;

{ **************************************************************************** }
{ *                                                                          * }
{ *   : TAutomatonSlotMachine.                                   * }
{ *                                                                          * }
{ **************************************************************************** }

  //
  // Switch 1
  //

  procedure  TAutomatonSlotMachine.HandleState(Event: TEvent);
  begin
    case State of
      0:  begin
            if ((Event=11) and (y1=1)) then
            begin
                                                    State := 1;
            end
            else if ((Event=11) and (y1=2)) then
            begin
              z02();                                State := 3;
            end;
          end;
      1:  begin
            if ((Event=11) and (y1=2)) then
            begin
              z02();                                State := 3;
            end
            else if ((Event=01) and (y1=1)) then
            begin
              A1(12);                               State := 2;
            end
            else if (Event=02) then
            begin
              z02(); A1(2);                         State := 0;
            end;
          end;
      2:  begin
            A2(Event);
            if ((Event = 05) and x01 and x02) then
            begin
              z04();                                State := 4;
            end
            else if ((Event = 05) and not x01) then
            begin
                                                    State := 0;
            end;
          end;
      3:  begin
            if ((Event=02) and (y1=2)) then
            begin
              A1(2);                                State := 0;
            end
            else if (Event=03) and (y1<>2) then
            begin
              z05(); z28(); z15();                  State := 0;
            end;
          end;
      4:  begin
            if ((Event = 06) and x01 and x02) then
            begin
              z04(); z28(); z15();
            end
            else if ((Event = 06) and x01 and not x02) then
            begin
              z28(); z15();                         State := 3
            end
            else if ((Event = 06) and not x01) then
            begin
              z28(); z15();                         State := 0;
            end;
          end;
      else
        if LogError then
          Log('   A0    e' + IntToStr(Event) +
              ':   ' + IntToStr(State));
    end;
  end;

  //
  // Switch 2
  //

  procedure TAutomatonSlotMachine.EnterState();
  begin
    case State of
      0: begin z03; z13(); z12(); end;
      2: A2(0);
    end;
  end;

  //
  // 
  //

  procedure TAutomatonSlotMachine.Log(AutomatonMessage: string);
  begin
    SlotMachine.Log.Lines.Add(DateToStr(Date) + ' ' + TimeToStr(Time)+':');
    SlotMachine.Log.Lines.Add(AutomatonMessage);
    SlotMachine.Log.Lines.Add('');
  end;

  //
  //   
  //

  function  TAutomatonSlotMachine.GetX01(): boolean;
  begin result := SlotMachine.JackPotCoinsCount > 0; end;

  function  TAutomatonSlotMachine.GetX02(): boolean;
  begin result := SlotMachine.BankCoinsCount > 0; end;

  //
  //  
  //

  procedure TAutomatonSlotMachine.z02();
  begin SlotMachine.MoneyTrayEnable(false); end;

  procedure TAutomatonSlotMachine.z03();
  begin SlotMachine.MoneyTrayEnable(true); end;

  procedure TAutomatonSlotMachine.z04();
  begin SlotMachine.PayFromBank(); end;

  procedure TAutomatonSlotMachine.z05();
  begin Slotmachine.JackPotCoinsCount :=0 ; end;

  procedure TAutomatonSlotMachine.z13();
  begin SlotMachine.Stake := 0; end;

  procedure TAutomatonSlotMachine.z12();
  begin SlotMachine.edStake.Text := IntToStr(SlotMachine.Stake); end;

  procedure TAutomatonSlotMachine.z28();
  begin SlotMachine.edJackPot.Text := IntToStr(SlotMachine.JackPotCoinsCount); end;

  procedure TAutomatonSlotMachine.z15();
  begin SlotMachine.edBank.Text := IntToStr(SlotMachine.BankCoinsCount); end;

  //
  //  
  //

  procedure TAutomatonSlotMachine.A1(Event: TEvent);
  begin atmDispatcher.Automatons[1].Wake(Event); end;

  procedure TAutomatonSlotMachine.A2(Event: TEvent);
  begin atmDispatcher.Automatons[2].Wake(Event); end;

  //
  //    
  //

  function  TAutomatonSlotMachine.GetY1: TState;
  begin result := atmDispatcher.Automatons[1].Y; end;

  function  TAutomatonSlotMachine.GetY2: TState;
  begin result := atmDispatcher.Automatons[2].Y; end;

{ **************************************************************************** }
{ *                                                                          * }
{ *   : TAutomatonMoneyTray.                                     * }
{ *                                                                          * }
{ **************************************************************************** }

  //
  // Switch 1
  //

  procedure TAutomatonMoneyTray.HandleState(Event: TEvent);
  begin
    case State of
      0:  begin
            if ((Event=10) and x11) then
            begin
              z12();                                State := 1;
            end
            else if ((Event=10) and not x11) then
            begin
              z12();                                State := 2;
            end;
          end;
      1:  begin
            if (Event=02) then
            begin
              z14();                                State := 0;
            end
            else if ((Event=10) and x11) then
            begin
              z12();                                
            end
            else if ((Event=10) and not x11) then
            begin
              z12();                                State := 2
            end
            else if (Event=12) then
            begin
              z02(); z13(); z15();                  State := 0;
            end;
          end;
      2:  begin
            if (Event=02) then
            begin
              z14();                                State := 0;
            end;
         end;
      else
       if LogError then
         Log('   A1    e' + IntToStr(Event) +
             ':   ' + IntToStr(State));
    end;
  end;

  //
  // Switch 2
  //

  procedure TAutomatonMoneyTray.EnterState();
  begin
    case State of
      1: A0(11);
      2: A0(11);
    end;
  end;

  //
  // 
  //

  procedure TAutomatonMoneyTray.Log(AutomatonMessage: string);
  begin
    SlotMachine.Log.Lines.Add(DateToStr(Date) + ' ' + TimeToStr(Time)+':');
    SlotMachine.Log.Lines.Add(AutomatonMessage);
    SlotMachine.Log.Lines.Add('');
  end;

  //
  //   
  //

  function  TAutomatonMoneyTray.GetX11(): boolean;
  begin result := SlotMachine.IsCoinOK(); end;

  //
  //  
  //

  procedure TAutomatonMoneyTray.z12();
  begin SlotMachine.edStake.Text := IntToStr(SlotMachine.Stake); end;

  procedure TAutomatonMoneyTray.z15();
  begin SlotMachine.edBank.Text := IntToStr(SlotMachine.BankCoinsCount); end;

  procedure TAutomatonMoneyTray.z02();
  begin SlotMachine.MoneyTrayEnable(false); end;

  procedure TAutomatonMoneyTray.z13();
  begin SlotMachine.RecieveMoney(); end;

  procedure TAutomatonMoneyTray.z14();
  begin SlotMachine.ReturnMoney(); end;

  //
  //  
  //

  procedure TAutomatonMoneyTray.A0(Event:TEvent);
  begin atmDispatcher.Automatons[0].Wake(Event); end;

{ **************************************************************************** }
{ *                                                                          * }
{ *   : TAutomatonBarrelsEngine.                                 * }
{ *                                                                          * }
{ **************************************************************************** }

  //
  // Switch 1
  //

  procedure TAutomatonBarrelsEngine.HandleState(Event: TEvent);
  begin
    case State of
      0:  begin
            if (Event=0) then
            begin
              z20();                                State := 1;
            end;
          end;
      1:  begin
            if (Event=22) then
            begin
                                                    State := 2
            end
            else if (Event=01) then
            begin
              z21();
            end;
          end;
      2:  begin
            if (Event=23) then
            begin
                                                    State := 3;
            end;
          end;
      3:  begin
            if (Event=05) then
              begin
                z27(); z28();                       State := 0;
              end;
          end;
      else
       if LogError then
         Log('   A2    e' + IntToStr(Event) +
             ':   ' + IntToStr(State));
    end;
  end;

  //
  // Switch 2
  //

  procedure TAutomatonBarrelsEngine.EnterState();
  begin
    case State of
      2: z23();
      3: z25();
    end;
  end;

  //
  // 
  //

  procedure TAutomatonBarrelsEngine.Log(AutomatonMessage: string);
  begin
    SlotMachine.Log.Lines.Add(DateToStr(Date) + ' ' + TimeToStr(Time)+':');
    SlotMachine.Log.Lines.Add(AutomatonMessage);
    SlotMachine.Log.Lines.Add('');    
  end;

  //
  //  
  //
  
  procedure TAutomatonBarrelsEngine.z20();
  begin
    SlotMachine.TimerSync1.Interval := 10;
    SlotMachine.TimerSync2.Interval := 1;
    SlotMachine.TimerSync3.Interval := 6;
  end;

  procedure TAutomatonBarrelsEngine.z21();
  begin
    if (SlotMachine.TimerB1.Interval=0) then
      SlotMachine.TimerB1.Interval := 1000 + Random(1000);
  end;

  procedure TAutomatonBarrelsEngine.z23();
  begin SlotMachine.TimerB2.Interval := 1000 + Random(1000) end;

  procedure TAutomatonBarrelsEngine.z25();
  begin SlotMachine.TimerB3.Interval := 1000 + Random(1000) end;

  procedure TAutomatonBarrelsEngine.z27();
  begin SlotMachine.SetJackPot(); end;

  procedure TAutomatonBarrelsEngine.z28();
  begin SlotMachine.edJackPot.Text := IntToStr(SlotMachine.JackPotCoinsCount); end;

{ **************************************************************************** }
{ *                                                                          * }
{ *    "atmSlotMachine.pas"                                       * }
{ *                                                                          * }
{ **************************************************************************** }

end.

